//ZSNO
//Parsing PGM files
//so fun
//paint color function stolen from spaceguy
function getClosestPaintColor(%rgba)
{
	%prevdist = 100000;
	%colorMatch = 0;
	for(%i = 0;%i < 64;%i++)
	{
		%color = getColorIDTable(%i);
		if(vectorDist(%rgba,getWords(%color,0,2)) < %prevdist && getWord(%rgba,3) - getWord(%color,3) < 0.3 && getWord(%rgba,3) - getWord(%color,3) > -0.3)
		{
			%prevdist = vectorDist(%rgba,%color);
			%colormatch = %i;
		}
	}
	return %colormatch;
}
//max height for area color
$ter::dirth = 0.5;
$ter::grassh = 0.8;
$ter::rockh = 0.9;
//area colors
$ter::dirt = getClosestPaintColor("0.386718 0.172549 0 1");
$ter::grass = getClosestPaintColor("0.148437 0.597656 0 1");
$ter::rock = getClosestPaintColor("0.25 0.25 0.25 1");
$ter::snow = getClosestPaintColor("1 1 1 1");
//parse the pgm file so it's easier for torque (me to script)
function preparePGM(%filen)
{
	%tot = "";
	%newfile = getSubStr(%filen,0,strLen(%filen) - 4) @ "_format.pgm";
	%file = new fileObject();
	%file.openForRead(%filen);
	%new = new fileObject();
	%new.openForWrite(%newfile);
	%derp = %file.readLine();
	if(!(%derp $= "P2"))
		return;
	%file.readLine();
	%size = %file.readLine();
	$ter::sizex = getWord(%size,0);
	$ter::sizey = getWord(%size,1);
	if(getWord(%size,0) > 512)
		$ter::sizex = 512;
	if(getWord(%size,1) > 512)
		$ter::sizey = 512;
	%height = %file.readLine();
	$ter::maxh = %height / 200;
//	$ter::offset = %file.readLine();
	%rows = getWord(%size,0) / 16;
	while(!%file.isEOF())
	{
		for(%i=0;%i<%rows;%i++)
			%tot = %tot @ %file.readLine();
		%new.writeLine(%tot);
		%tot = "";
	}
	%file.close();
	%file.delete();
	%new.close();
	%new.delete();
}
//now build the file
//use this function as it includes the prepare
//if you want it to change the formated PGM file, delete the file
function parsePGM(%filen)
{
	if(!isFile(%filen))
	{
		warn("Not an existing file!");
		return;
	}
	if(!(isFile(getSubStr(%filen,0,strLen(%filen) - 4) @ "_format.pgm")))
		preparePGM(%filen);
	%file = new fileObject();
	%file.openForRead(getSubStr(%filen,0,strLen(%filen) - 4) @ "_format.pgm");
	%count = 1;
	%x = 0;// getWord($ter::offset,0);
	%y = 0;// getWord($ter::offset,1);
	%z = 0;
//	%client = findclientbyname(z);
	while(%count <= $ter::sizey)
	{
		%line = %file.readLine();
		for(%i=0;%i<$ter::sizex;%i++)
		{
			%z = (getWord(%line,%i) / 100);
			if(%z > ($ter::maxh * $ter::rockh))
				%color = $ter::snow;
			else if(%z <= ($ter::maxh * $ter::rockh) && %z  > ($ter::maxh * $ter::grassh))
				%color = $ter::rock;
			else if(%z <= ($ter::maxh * $ter::grassh) && %z > ($ter::maxh * $ter::dirth))
				%color = $ter::grass;
			else
				%color = $ter::dirt;
			%brick = new fxDTSBrick()
			{
				position = %x*2 SPC %y*2 SPC %z;
				datablock = brick4x16CubeData;
				colorID = %color;
				isPlanted = 1;
				client = %client;
				rotation = "0 0 0 0";
				scale = "1 1 1";
				angleID = "0";
				colorfxID = 0;
				shapefxID = 0;
				isBaseplate = 1;
			};
			%brick.plant();
			%brick.setTrusted(1);
			BrickGroup_888888.add(%brick);
			%x++;
		}
		%x = 0;// getWord($ter::offset,0);
		%y++;
		%count++;
	}
	%file.close();
	%file.delete();
}